const { spawn, spawnSync, exec } = require('child_process')
const chalk = require('chalk')

const { TEMPLATES } = require('./question')
const { isYarn, CURR_DIR } = require('./helper')
const { appConfig } = require('./config')
const { copy } = require('fs-extra')

module.exports.createTypescriptProject = ({ name, template, onlyPlus }) => {
  const TARGET_PATH = `${CURR_DIR}/ahihi`
  console.log('TARGET_PATH:', TARGET_PATH)

  if (!name) {
    name = 'abhihi-reactjs-ts-app'
  }
  name = `${TARGET_PATH}/${name}`

  if (!TEMPLATES.includes(template)) {
    template = 'typescript'
  }

  // if (!onlyPlus) {
  //   // create react ts app
  //   spawn(isYarn ? 'yarn' : 'npx', [`${isYarn ? 'create react-app' : 'create-react-app'} ${name} --template typescript`], { shell: true, stdio: 'inherit' })
  // }

  console.log('CURR_DIR:', CURR_DIR)

  console.log(chalk.green(`🥳 Start generate file ...`))
  const packagePath = `${CURR_DIR}/node_modules/${appConfig.packageName}/source-code`
  copy(`${packagePath}/.husky`, TARGET_PATH)
  copy(`${packagePath}/.vscode`, TARGET_PATH)
  copy(`${packagePath}/env`, `${TARGET_PATH}/public`)
  copy(`${packagePath}/.vscode`, TARGET_PATH)
  copy(`${packagePath}/src`, TARGET_PATH)

  copy(`${packagePath}/.editorconfig`, TARGET_PATH)
  copy(`${packagePath}/.env.development`, TARGET_PATH)
  copy(`${packagePath}/.env.production`, TARGET_PATH)
  copy(`${packagePath}/.env.testing`, TARGET_PATH)
  copy(`${packagePath}/.env.uat`, TARGET_PATH)
  copy(`${packagePath}/.prettierignore`, TARGET_PATH)
  copy(`${packagePath}/.prettierrc`, TARGET_PATH)
}
